Experiments-3
For instructions on how to authenticate to use this endpoint, see API overview.
Endpoints
POST | |
POST | |
GET | |
GET | |
GET | |
GET |
Create experiments resume
Resume a paused experiment.
Reactivates the linked feature flag so it is returned by /decide again. Users are re-bucketed deterministically into the same variants they had before the pause, and exposure tracking resumes. Returns 400 if the experiment is not running or is not paused.
Required API key scopes
experiment:writePath parameters
- idinteger
- project_idstring
Response
Example request
POST /api /projects /:project_id /experiments /:id /resumeExample response
Status 200
Create experiments resume
Resume a paused experiment.
Reactivates the linked feature flag so it is returned by /decide again. Users are re-bucketed deterministically into the same variants they had before the pause, and exposure tracking resumes. Returns 400 if the experiment is not running or is not paused.
Required API key scopes
experiment:writePath parameters
- idinteger
- project_idstring
Response
Example request
POST /api /projects /:project_id /experiments /:id /resumeExample response
Status 200
Create experiments ship variant
Ship a variant to 100% of users and (optionally) end the experiment.
Rewrites the feature flag so that the selected variant is served to everyone. Existing release conditions (flag groups) are preserved so the change can be rolled back by deleting the auto-added release condition in the feature flag UI.
Can be called on both running and stopped experiments. If the experiment is still running, it will also be ended (end_date set and status marked as stopped). If the experiment has already ended, only the flag is rewritten - this supports the "end first, ship later" workflow.
If an approval policy requires review before changes on the flag take effect, the API returns 409 with a change_request_id. The experiment is NOT ended until the change request is approved and the user retries.
Returns 400 if the experiment is in draft state, the variant_key is not found on the flag, or the experiment has no linked feature flag.
Required API key scopes
experiment:writePath parameters
- idinteger
- project_idstring
Request parameters
- conclusion
- conclusion_commentstring
- variant_keystring
Response
Example request
POST /api /projects /:project_id /experiments /:id /ship_variantExample response
Status 200
Create experiments ship variant
Ship a variant to 100% of users and (optionally) end the experiment.
Rewrites the feature flag so that the selected variant is served to everyone. Existing release conditions (flag groups) are preserved so the change can be rolled back by deleting the auto-added release condition in the feature flag UI.
Can be called on both running and stopped experiments. If the experiment is still running, it will also be ended (end_date set and status marked as stopped). If the experiment has already ended, only the flag is rewritten - this supports the "end first, ship later" workflow.
If an approval policy requires review before changes on the flag take effect, the API returns 409 with a change_request_id. The experiment is NOT ended until the change request is approved and the user retries.
Returns 400 if the experiment is in draft state, the variant_key is not found on the flag, or the experiment has no linked feature flag.
Required API key scopes
experiment:writePath parameters
- idinteger
- project_idstring
Request parameters
- conclusion
- conclusion_commentstring
- variant_keystring
Response
Example request
POST /api /projects /:project_id /experiments /:id /ship_variantExample response
Status 200
Retrieve experiments timeseries results
Mixin for ViewSets to handle ApprovalRequired exceptions from decorated serializers.
This mixin intercepts ApprovalRequired exceptions raised by the @approval_gate decorator on serializer methods and converts them into proper HTTP 409 Conflict responses with change request details.
Required API key scopes
experiment:readPath parameters
- idinteger
- project_idstring
Example request
GET /api /projects /:project_id /experiments /:id /timeseries_resultsExample response
Status 200 No response body
Retrieve experiments timeseries results
Mixin for ViewSets to handle ApprovalRequired exceptions from decorated serializers.
This mixin intercepts ApprovalRequired exceptions raised by the @approval_gate decorator on serializer methods and converts them into proper HTTP 409 Conflict responses with change request details.
Required API key scopes
experiment:readPath parameters
- idinteger
- project_idstring
Example request
GET /api /projects /:project_id /experiments /:id /timeseries_resultsExample response
Status 200 No response body
Retrieve experiments eligible feature flags
Returns a paginated list of feature flags eligible for use in experiments.
Eligible flags must:
- Be multivariate with at least 2 variants
- Have "control" as the first variant key
Query parameters:
- search: Filter by flag key or name (case insensitive)
- limit: Number of results per page (default: 20)
- offset: Pagination offset (default: 0)
- active: Filter by active status ("true" or "false")
- created_by_id: Filter by creator user ID
- order: Sort order field
- evaluation_runtime: Filter by evaluation runtime
- has_evaluation_contexts: Filter by presence of evaluation contexts ("true" or "false")
Required API key scopes
feature_flag:readPath parameters
- project_idstring
Example request
GET /api /projects /:project_id /experiments /eligible_feature_flagsExample response
Status 200 No response body
Retrieve experiments eligible feature flags
Returns a paginated list of feature flags eligible for use in experiments.
Eligible flags must:
- Be multivariate with at least 2 variants
- Have "control" as the first variant key
Query parameters:
- search: Filter by flag key or name (case insensitive)
- limit: Number of results per page (default: 20)
- offset: Pagination offset (default: 0)
- active: Filter by active status ("true" or "false")
- created_by_id: Filter by creator user ID
- order: Sort order field
- evaluation_runtime: Filter by evaluation runtime
- has_evaluation_contexts: Filter by presence of evaluation contexts ("true" or "false")
Required API key scopes
feature_flag:readPath parameters
- project_idstring
Example request
GET /api /projects /:project_id /experiments /eligible_feature_flagsExample response
Status 200 No response body
Retrieve experiments requires flag implementation
Mixin for ViewSets to handle ApprovalRequired exceptions from decorated serializers.
This mixin intercepts ApprovalRequired exceptions raised by the @approval_gate decorator on serializer methods and converts them into proper HTTP 409 Conflict responses with change request details.
Required API key scopes
experiment:readPath parameters
- project_idstring
Example request
GET /api /projects /:project_id /experiments /requires_flag_implementationExample response
Status 200 No response body
Retrieve experiments requires flag implementation
Mixin for ViewSets to handle ApprovalRequired exceptions from decorated serializers.
This mixin intercepts ApprovalRequired exceptions raised by the @approval_gate decorator on serializer methods and converts them into proper HTTP 409 Conflict responses with change request details.
Required API key scopes
experiment:readPath parameters
- project_idstring
Example request
GET /api /projects /:project_id /experiments /requires_flag_implementationExample response
Status 200 No response body
Retrieve experiments stats
Mixin for ViewSets to handle ApprovalRequired exceptions from decorated serializers.
This mixin intercepts ApprovalRequired exceptions raised by the @approval_gate decorator on serializer methods and converts them into proper HTTP 409 Conflict responses with change request details.
Required API key scopes
experiment:readPath parameters
- project_idstring
Example request
GET /api /projects /:project_id /experiments /statsExample response
Status 200 No response body
Retrieve experiments stats
Mixin for ViewSets to handle ApprovalRequired exceptions from decorated serializers.
This mixin intercepts ApprovalRequired exceptions raised by the @approval_gate decorator on serializer methods and converts them into proper HTTP 409 Conflict responses with change request details.
Required API key scopes
experiment:readPath parameters
- project_idstring
Example request
GET /api /projects /:project_id /experiments /stats